# Building Protection
Ever had an idea for a dungeon or enemy fortress on your server for your players to fight their way through?  
Tired of game updates breaking your building mods, causing your builds to collapse into a pile of chaos?  
This may be the mod you're looking for!

## Indestructible builds await!
The goal of the plugin is to allow admins or designated builders to create builds that are classified as "non-player" .  
Enemies wont attack them. They won't take damage from any source, and won't allow players to remove or destroy them.  
Now you can build floating buildings, npc homes, community portal hubs, enemy strongholds, dungeons, server jails, and more!

## Initial Setup
This plugin is required on the server AND all clients to properly function.  
If single-player only, then only the one client needs the plugin.  
When installed on a server, any client that does not have the plugin installed will be disconnected.   
This is a safeguard to prevent players without the mod from demolishing protected builds with their hammer.  
**NOTE:** Server means either a dedicated server, or the player that is hosting a multiplayer game.

## Instructions
**SERVER**  
Install on your dedicated server, then reboot it.  
By default ALL admins in your adminlist.txt will have the ability to access protected build mode.  
To change this, open the KhaibaGaming.BuildingProtection.cfg in Valheim/BepInEx/config and add the specific steamIDs of any players who should have access to protected building to the Permitted IDs field and set Disable Admins to true.  
This plugin also uses SmoothBrain's Server-Sync to force clients to use the server's settings, so no need for client configuration.

**CLIENT**  
Install on your client, then launch the game.  
If you are playing single-player or hosting a multiplayer game, you will be auto-permitted for protected build mode.  
You may give permission to anyone by doing either:  
1 - Adding them in the KhaibaGaming.BuildingProtection.cfg located at ( Valheim/BepInEx/config ) by adding their steamID in the Permitted IDs field.  
2 - Adding them your adminlist.txt located at ( C:\USER\AppData\LocalLow\Irongate\Valheim\adminlist.txt )  

**PLAYER**  
While in the game, type "/protect" in chat (or "protect" in the console) to toggle between protected building and normal building.  
Keep in mind that you must toggle off "/protect" if you want to build normally again.   
Protected build mode resets to off upon logout or disconnect.

## What this mod does!
Anything built while in "protected building mode" will:
- Have infinite health and take no damage from weather, structural support, or attacks.
- Cost 0 stamina and 0 durability to place, remove, or repair.
- Be completely ignored by enemy monsters.
- Be unremovable by players who are not in "protected building mode". 
- Be distinguishable from unprotected pieces via the lightblue health bar of the piece instead of the normal yellow.  
- Have their fuel auto set to max and disable fuel consumption for all "light-source" fireplaces/torches.  

You can use the repair function of your hammer while in "protected building mode" to change an existing unprotected item to protected.  

## What this mod does not do!
- Provide perfectly cooked fried chicken seasoned with 11 secret herbs and spices.
- Outfit your Viking with a fashionable and festive hat to wear for social outings.
- Turn your build hammer into an all-knowing, all-seeing creator of fantastic builds... well, mayyybe...
- Retrieve loose change and lost socks from the wormhole to the fifth dimension located within your dryer.
- Leave one star reviews on yelp regarding the quality and temperature of the food you ordered.

## Change Log
- 2.0.3 Updated for Valheim's latest patch which fiddled with worldtexts and rich text in chat/terminal essentially borking the entire mod.
- 2.0.0 Included Gizmo++ which is disabled by default (in case you use another gizmo). This one has a smaller gizmo and allows you to move it up and down for better visibility as well as an all-axis reset keybind.
- 1.0.3 Added feature to auto-max fuel sources on all "light-source" fireplaces/torches when "Protected" and disable fuel consumption on them.
- 1.0.2 Added the ability to repair existing builds into "Protected" builds
- 1.0.1 Initial public release

## Special thanks to:
- Discord user "Kalek" for reporting an issue with the plugin loading after a valheim update. Jan 29 2023
- Discord user "Raine" for reporting an issue with the plugin loading after another valheim update. Mar 13 2023
My time is split between several projects in other games, but I will keep this up to date whenever I'm informed it is needed. THANKS!

### Happy Building!